#include "stdafx.h"
#include "bibtexset.h"
#include "setting.h"
#include "resource.h"

extern Setting g_setting;

bool BibTeXSet::OnInitDialog(ablib::window::Dialog *wnd){
	switch(g_setting.BibTeX_WhichProgram()){
	case bibtex:
		ablib::window::CheckBox(wnd,IDC_BIBTEX).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;

	case other:
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).SetCheck(true);
		break;

	case jbibtex:
	default:
		ablib::window::CheckBox(wnd,IDC_JBIBTEX).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;
	}
	ablib::window::Edit(wnd,IDC_PROGRAM).SetText(g_setting.BibTeX_Program());
	ablib::window::Edit(wnd,IDC_OPTION).SetText(g_setting.BibTeX_Option());
	return true;
}

bool BibTeXSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_BIBTEX:
	case IDC_JBIBTEX:
	case IDC_OTHERPROGRAM:
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		return true;
		
	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_BIBTEX).GetCheck()){
			g_setting.WriteBibTeX_WhichProgram(bibtex);
		}else if(ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()){
			g_setting.WriteBibTeX_WhichProgram(other);
		}else{
			g_setting.WriteBibTeX_WhichProgram(jbibtex);
		}
		g_setting.WriteBibTeX_Program(ablib::window::Edit(wnd,IDC_PROGRAM).GetText());
		g_setting.WriteBibTeX_Option(ablib::window::Edit(wnd,IDC_OPTION).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}

