#include "stdafx.h"
#include "dvioutset.h"
#include "setting.h"
#include "resource.h"

extern Setting g_setting;

const TCHAR *DVIOUTSet::m_papersize[] = {
	_T("A3"),_T("A4"),_T("A5"),_T("A6"),_T("A7"),_T("B3E"),_T("B4E"),_T("B5E"),_T("B6E"),
	_T("B3J"),_T("B4J"),_T("B5J"),_T("B6J"),_T("KIKU"),_T("46"),_T("NB"),_T("AB"),_T("Legal"),
	_T("GovLegal"),_T("Letter"),_T("HalfLetter"),_T("GovLetter"),_T("Execute"),_T("͂"),
	_T("SVGA"),_T("XGA"),_T("SXGA"),_T("UVGA"),NULL
};

bool DVIOUTSet::OnInitDialog(ablib::window::Dialog *wnd){
	if(g_setting.DVIOUT_IsUseDVIOUT())ablib::window::CheckBox(wnd,IDC_USEDVIOUT).SetCheck(true);
	else ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).SetCheck(true);

	if(g_setting.DVIOUT_Maximize())ablib::window::CheckBox(wnd,IDC_MAXIMIZE).SetCheck(true);
	if(g_setting.DVIOUT_IsTellPaperSize())ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).SetCheck(true);
	switch(g_setting.DVIOUT_WhichPaperSize()){
	case list:
		ablib::window::CheckBox(wnd,IDC_PAPER_ITIRAN).SetCheck(true);
		break;

	case number:
		ablib::window::CheckBox(wnd,IDC_PAPER_NUM).SetCheck(true);
		break;

	case guess:
	default:
		ablib::window::CheckBox(wnd,IDC_PAPER_SUITEI).SetCheck(true);
		break;
	}
	ablib::window::Edit(wnd,IDC_DVIOUTPATH).SetText(g_setting.DVIOUT_dvioutPath());
	ablib::window::Edit(wnd,IDC_HEIGHT).SetText(g_setting.DVIOUT_PaperSizeX());
	ablib::window::Edit(wnd,IDC_WIDTH).SetText(g_setting.DVIOUT_PaperSizeY());

	ablib::string paper = g_setting.DVIOUT_PaperSizeFromList();
	ablib::window::Combo pc(wnd,IDC_COMBO_PAPER);
	for(const TCHAR **p = m_papersize ; *p ; ++p)pc.AddString(*p);
	int n = pc.GetCount();
	for(int i = 0 ; i < n ; ++i)if(pc.GetText(i) == paper)pc.SetCurSel(i);

	ablib::window::Edit(wnd,IDC_DVIOUTPATH).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::CheckBox(wnd,IDC_MAXIMIZE).Enabled(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).Enabled(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPER_SUITEI).Enabled(
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPER_ITIRAN).Enabled(
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPER_NUM).Enabled(
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
	ablib::window::Combo(wnd,IDC_COMBO_PAPER).Enabled(
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() && 
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_PAPER_ITIRAN).GetCheck());
	ablib::window::Edit(wnd,IDC_HEIGHT).Enabled(
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_PAPER_NUM).GetCheck());
	ablib::window::Edit(wnd,IDC_WIDTH).Enabled(
		ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
		ablib::window::CheckBox(wnd,IDC_PAPER_NUM).GetCheck());

	ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
	ablib::window::Edit(wnd,IDC_ARG).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
	return true;
}

bool DVIOUTSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_USEDVIOUT:
	case IDC_OTHERPROGRAM:
	case IDC_ISTELLPAPERSIZE:
	case IDC_PAPER_ITIRAN:
	case IDC_PAPER_SUITEI:
	case IDC_PAPER_NUM:
		ablib::window::Edit(wnd,IDC_DVIOUTPATH).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::CheckBox(wnd,IDC_MAXIMIZE).Enabled(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).Enabled(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPER_SUITEI).Enabled(
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPER_ITIRAN).Enabled(
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPER_NUM).Enabled(
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		ablib::window::Combo(wnd,IDC_COMBO_PAPER).Enabled(
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() && 
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_PAPER_ITIRAN).GetCheck());
		ablib::window::Edit(wnd,IDC_HEIGHT).Enabled(
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_PAPER_NUM).GetCheck());
		ablib::window::Edit(wnd,IDC_WIDTH).Enabled(
			ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck() &&
			ablib::window::CheckBox(wnd,IDC_PAPER_NUM).GetCheck());

		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		ablib::window::Edit(wnd,IDC_ARG).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		return true;
	
	case IDC_SANSYO_DVIOUTPATH:
		if(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck()){
			ablib::string p;
			if(ablib::window::CommonDlg(wnd).OpenFileDlg(p,
				_T("dviout.exe\0dviout.exe\0SẴt@C(*.*)\0*.*\0"),
				_T("dviout̏ꏊIłD"),
				g_setting.DVIOUT_dvioutPath().c_str()))ablib::window::Edit(wnd,IDC_DVIOUTPATH).SetText(p);
			return true;
		}else return false;

	case IDC_PROGRAM_SANSYO:
		if(ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()){
			ablib::string p;
			if(ablib::window::CommonDlg(wnd).OpenFileDlg(p,
				_T("st@C(*.exe)\0*.exe\0SẴt@C(*.*)\0*.*\0"),
				_T("dviout̏ꏊIłD"),
				g_setting.DVIOUT_Program().c_str()))ablib::window::Edit(wnd,IDC_PROGRAM).SetText(p);
			return true;
		}else return false;


	case IDOK:
		g_setting.WriteDVIOUT_IsUseDVIOUT(ablib::window::CheckBox(wnd,IDC_USEDVIOUT).GetCheck());
		g_setting.WriteDVIOUT_dvioutPath(ablib::window::Edit(wnd,IDC_DVIOUTPATH).GetText());
		g_setting.WriteDVIOUT_Maximize(ablib::window::CheckBox(wnd,IDC_MAXIMIZE).GetCheck());
		g_setting.WriteDVIOUT_IsTellPaperSize(ablib::window::CheckBox(wnd,IDC_ISTELLPAPERSIZE).GetCheck());
		if(ablib::window::CheckBox(wnd,IDC_PAPER_SUITEI).GetCheck()){
			g_setting.WriteDVIOUT_WhichPaperSize(guess);
		}else if(ablib::window::CheckBox(wnd,IDC_PAPER_NUM).GetCheck()){
			g_setting.WriteDVIOUT_WhichPaperSize(number);
		}else{
			g_setting.WriteDVIOUT_WhichPaperSize(list);
		}
		g_setting.WriteDVIOUT_PaperSizeFromList(ablib::window::Combo(wnd,IDC_COMBO_PAPER).GetText());
		g_setting.WriteDVIOUT_PaperSizeX(ablib::window::Edit(wnd,IDC_HEIGHT).GetText());
		g_setting.WriteDVIOUT_PaperSizeY(ablib::window::Edit(wnd,IDC_WIDTH).GetText());
		
		g_setting.WriteDVIOUT_Program(ablib::window::Edit(wnd,IDC_PROGRAM).GetText());
		g_setting.WriteDVIOUT_Arg(ablib::window::Edit(wnd,IDC_ARG).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}
