#include "stdafx.h"
#include <vector>
#include <ablib/KRSearch.h>
#include <regex>
#include "func.h"

bool IsNormalFile(const TCHAR *path){
#ifdef UNICODE
	std::wregex reg;
#else
	std::regex reg;
#endif
	reg.assign(_T("^([a-zA-Z]:\\\\|\\\\\\\\)?([^\\\\/:*?\"<>|]+[\\\\/])*[^\\\\/:*?\"<>|]+$"));
	return std::regex_match(path, reg);
}


void split(std::vector<ablib::string> &rvalue,const TCHAR *value,const TCHAR *key){
	TCHAR *p,*q,*string = new TCHAR[::lstrlen(value) + 1],tmp;
	::lstrcpy(string,value);
	q = string;
	while(p = ablib::KRSearch::strstr(q,key)){
		tmp = *p;*p = '\0';
		rvalue.push_back(q);
		*p = tmp;q = p + ::lstrlen(key);
	}
	rvalue.push_back(q);
	delete[] string;
	return;
}


const TCHAR *TransRegularPath(const TCHAR *fn){
	static ablib::string rv;
	std::vector<ablib::string> sa,sa2;
	UINT i;
	int len = 0;
	split(sa,const_cast<TCHAR *>(fn),_T("\\"));
	for(i = 0 ; i < sa.size() ; ++i){
		if(sa[i] == _T("."))continue;
		else if(sa[i] == _T("..")){if(!sa2.empty())sa2.pop_back();}
		else if(sa[i] == _T(""))continue;
		else sa2.push_back(sa[i]);
	}
	rv = _T("");
	for(i = 0 ; i < sa2.size() ; ++i){
		if(i != 0)rv += _T("\\");
		rv += sa2[i];
	}
	return rv.c_str();
}


bool CheckSameFile(const TCHAR *filename1,const TCHAR *filename2){
	ablib::string f1,f2;
	if(::lstrcmp(filename1,_T("")) == 0 || ::lstrcmp(filename2,_T("")) == 0)return false;
	f1 = TransRegularPath(filename1);
	f2 = TransRegularPath(filename2);
	f1.tolower();
	f2.tolower();
	return (f1 == f2);
}

const TCHAR *Which(const TCHAR *cmd){
	static ablib::string rv;
	std::vector<ablib::string> envpath;
	ablib::string path;
	int bufsize = ::GetEnvironmentVariable(_T("PATH"),NULL,0) + 1;
	TCHAR *env = new TCHAR[bufsize + 1];
	::GetEnvironmentVariable(_T("PATH"),env,bufsize);
	::split(envpath,env,_T(";"));
	delete[] env;
	UINT i;
	for(i = 0 ; i < envpath.size() ; ++i){
		if(envpath[i][envpath[i].length()-1] != '\\')envpath[i] += _T("\\");
		path = envpath[i];
		path += cmd;
		path += _T(".exe");
		if(::GetFileAttributes(path.c_str()) != -1){
			rv = envpath[i];
			return rv.c_str();
		}
	}
	rv = _T("");
	return rv.c_str();
}

