#include "stdafx.h"
#include "history.h"
#include <vector>
#include "ablib/lexical_cast.h"

History::History(int max) : m_max(max){
	TCHAR buf[4096];
	::GetModuleFileName(NULL,buf,4095);
	m_inifile = buf;
	m_inifile.erase(m_inifile.rfind(_T(".")));
	m_inifile += _T(".ini");
}

void History::Add(const ablib::string &hist){
	if(hist == _T(""))return;
	int i;
	std::vector<ablib::string> hists;
	TCHAR buf[4096];
	for(i = 0 ; i < m_max ; ++i){
		::GetPrivateProfileString(_T("History"),ablib::lexical_cast<ablib::string>(i).c_str(),_T(""),
			buf,4095,m_inifile.c_str());
		hists.push_back(buf);
		if(hist == buf || ::lstrcmp(buf,_T("")) == 0)break;
	}
	++i;
	::WritePrivateProfileString(_T("History"),_T("0"),hist.c_str(),m_inifile.c_str());
	for(int j = 1 ; j < i ; ++j){
		::WritePrivateProfileString(_T("History"),ablib::lexical_cast<ablib::string>(j).c_str(),
			hists[j - 1].c_str(),m_inifile.c_str());
	}
	if(::lstrcmp(buf,_T("")) == 0){
		::WritePrivateProfileString(_T("History"),ablib::lexical_cast<ablib::string>(i).c_str(),
			_T(""),m_inifile.c_str());
	}
}

ablib::string History::Get(int i){
	if(i < 0 || i > m_max)return ablib::string(_T(""));
	TCHAR buf[4096];
	::GetPrivateProfileString(_T("History"),ablib::lexical_cast<ablib::string>(i).c_str(),
		_T(""),buf,4095,m_inifile.c_str());
	return ablib::string(buf);
}