#ifndef __MAINWND_H__
#define __MAINWND_H__

#include "window/BaseWnd.h"
#include "editor/EditWnd.h"
#include "window/BaseDlg.h"
#include "window/BaseModalDlg.h"
#include "ablib/CmdLine.h"
#include "system/Process.h"
#include "resource.h"
#include "TeX.h"
#include "History.h"

class MainWnd : public ablib::window::BaseWnd
{
public:
	MainWnd(HINSTANCE appint);
	~MainWnd(){}
	bool Create(){
		ablib::window::Window *rv = BaseWnd::Create(NULL);
		if(rv)rv->ShowWindow(ablib::window::Wnd::sw_show);
		return rv != NULL;
	}
	bool Exec(const ablib::string &cmd,const ablib::string &dir);
	// ̂܂܏IȂTRUED
	bool CmdLine(const ablib::CmdLine &cmd);
	DWORD GetReturnCode() {
		return m_process.ExitCode();
	}

private:
	bool OnCreate(ablib::window::Window *wnd);
	bool OnSize(ablib::window::Window *wnd,int sw,int width,int height);
	bool OnCommand(ablib::window::Window *wnd,int id,int param);
	bool OnSetFocus(ablib::window::Window *wnd,ablib::window::Window *old);
	bool OnDropFiles(const std::vector<ablib::string> &files);

	void SetMenu();
	struct Edit : public ablib::window::edit::EditWnd{
	public:
		Edit(HINSTANCE appint,ablib::system::Process *p) : EditWnd(appint),m_process(p){}
	private:
		bool OnChar(ablib::window::Window *wnd,TCHAR ch,int repeat);
		bool OnKey(ablib::window::Window *wnd,bool isDown,UINT vk,int repeat){
			if(vk == VK_BACK)return false;
			else return EditWnd::OnKey(wnd,isDown,vk,repeat);
		}
		bool OnRButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos,bool isDClick);
		ablib::string m_keybuf;
		ablib::system::Process *m_process;
	}m_edit;
	TeX m_tex;
	ablib::system::Process m_process;

	class BarDlg : public ablib::window::BaseDlg{
	public:
		BarDlg(HINSTANCE appint) : BaseDlg(appint){}
		~BarDlg(){}
		ablib::window::Dialog *Create(ablib::window::Wnd *wnd){return BaseDlg::Create(wnd,IDD_BARDLG);}
	}m_bardlg;

	class Version : public ablib::window::BaseModalDlg{
	public:
		Version(HINSTANCE appint) : BaseModalDlg(appint){}
		~Version(){}
		int Create(ablib::window::Wnd *parent){return BaseModalDlg::Create(parent,IDD_VERSION);}
		bool OnClose(ablib::window::Dialog *wnd){wnd->Destroy(0);return true;}
		bool OnCommand(ablib::window::Dialog *wnd,int id,int param){
			if(id == IDOK){wnd->Destroy(0);return true;}else return false;
		}
	};

	History m_history;

	static TBBUTTON m_toolbar[];

};

#endif //__MAINWND_H__

