
#ifndef __TEX_H__
#define __TEX_H__

#include "editor/EditWnd.h"
#include "History.h"

class MainWnd;

class TeX
{
public:
	TeX(ablib::window::edit::EditWnd *out) : m_output(out){};
	~TeX(){}
	void SetMainWnd(MainWnd *wnd){m_mainwnd = wnd;}
	void SetFile(const ablib::string &f, History &his) { m_filename = f; his.Add(f); }
	bool TeX2DVI();
	bool DVI2PS();
	bool DVI2PDF();
	bool PS2PDF();
	bool DVIPreview();
	bool PSPreview();
	bool PDFPreview();
	bool MakeIndex(){return MakeIndex(m_parent + m_parenttype);}
	bool BibTeX(){return BibTeX(m_parent + m_parenttype);}
	void GetDocumentInfo();

	enum ToDO{none,tex2dvi,dvi2ps,dvi2pdf,ps2pdf};
	static ToDO GetToDO(const ablib::string &file);
	ToDO GetToDO(){return GetToDO(m_filename);}
	bool DO(ToDO todo);


	ablib::string GetFile() const{return m_filename;}
	ablib::string GetDir() const{return m_dir;}
	ablib::string TransStr(const ablib::string &s);

private:
	ablib::window::edit::EditWnd *m_output;
	MainWnd *m_mainwnd;
	ablib::string m_filename;

	ablib::string m_parent,m_parentbase,m_parenttype,m_parentdir,m_documentoption,m_documentclass;
	ablib::string m_file,m_base,m_dir,m_type;

	bool MakeIndex(const ablib::string &f);
	bool BibTeX(const ablib::string &f);
	bool Exec(const ablib::string &cmd);

	const TCHAR *Getjpbibtex();
};

#endif //__TEX_H__

