#include "stdafx.h"
#include "MainWnd.h"
#include "Setting.h"
#include <system/Registory.h>
#include <ablib/CmdLine.h>
#include <ablib/IsKanji.h>
#include <Shlwapi.h>

HINSTANCE g_appint;
Setting g_setting;

ablib::string GesPath(const TCHAR *ext){
	TCHAR tmpdir[4096];
	::GetTempPath(4095, tmpdir);
	TCHAR tmpbase[MAX_PATH + 1];
	::GetTempFileName(tmpdir, ext, 0, tmpbase);
	ablib::string tmpfile = ablib::string(tmpdir) + _T("\\") + tmpbase;
	static TCHAR path[MAX_PATH + 1] = { 0 };
	FILE *fp = ::_tfopen(tmpfile.c_str(), _T("w"));
	if (fp) {
		::fclose(fp);
		if (::GetFileAttributes(tmpfile.c_str()) != -1) {
			if (reinterpret_cast<unsigned int>(::FindExecutable(tmpfile.c_str(), NULL, path)) > 32) {
				::DeleteFile(tmpfile.c_str());
				return path;
			}
		}
		::DeleteFile(tmpfile.c_str());
	}
	DWORD size = MAX_PATH;
	HRESULT const hr = ::AssocQueryString(ASSOCF_NOTRUNCATE, ASSOCSTR_EXECUTABLE, ext, "open", path, &size);
	if (SUCCEEDED(hr) && size > 0) {
		return path;
	} else {
		return _T("");
	}
	/*
	ablib::system::Registory reg;
	if(!reg.Open(HKEY_CLASSES_ROOT,t))return _T("");
	ablib::string type = reg.ReadStr(_T(""));
	reg.Close();
	type += _T("\\Shell\\open\\command");
	if(!reg.Open(HKEY_CLASSES_ROOT,type.c_str()))return _T("");
	ablib::string s = reg.ReadStr(_T(""));
	reg.Close();
	bool dq = false;
	ablib::string::size_type p = 0;
	for(p = 0 ; p < s.length() ; ++p){
#ifndef UNICODE
		if(ablib::IsKanji(s[p]))++p;
		else
#endif
		     if(s[p] == '\"')dq = !dq;
		else if(s[p] == ' ' && !dq)break;
	}
	s.erase(p);
	s.replace(_T("\""),_T(""));
	return s;*/
}




void CreateDefaultSetting(){
	g_setting.WriteTeX2DVI_IsUsingFormat(true);
	g_setting.WriteTeX2DVI_FormatFile(_T("platex.fmt"));
	g_setting.WriteTeX2DVI_IsAnalyze(true);
	g_setting.WriteTeX2DVI_MaxCompile(10);

	g_setting.WriteBibTeX_WhichProgram(2);

	g_setting.WriteMakeIndex_WhichProgram(2);

	g_setting.WriteDVI2PS_WhichProgram(2);

	g_setting.WritePS2PDF_IsGhostScript(true);

	g_setting.WriteDVI2PDF_WhichProgram(2);
	g_setting.WriteDVI2PDF_PaperSizeFromList(_T("a4"));

	g_setting.WriteDVIOUT_IsUseDVIOUT(true);
	g_setting.WriteDVIOUT_dvioutPath(GesPath(_T(".dvi")));
	g_setting.WriteDVIOUT_IsTellPaperSize(true);
	g_setting.WriteDVIOUT_Maximize(true);
	g_setting.WriteDVIOUT_WhichPaperSize(1);
	g_setting.WriteDVIOUT_PaperSizeFromList(_T("B5J"));

	g_setting.WritePSPreview_Program(GesPath(_T(".ps")));
	g_setting.WritePSPreview_Arg(_T("\"%F.ps\""));

	g_setting.WritePDFPreview_Program(GesPath(_T(".pdf")));
	g_setting.WritePDFPreview_Arg(_T("\"%F.pdf\""));

	return;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
	g_appint = hInstance;
	{
		INITCOMMONCONTROLSEX icc;
		::ZeroMemory(&icc,sizeof(INITCOMMONCONTROLSEX));
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = ICC_COOL_CLASSES;
		::InitCommonControlsEx(&icc);
	}

	if(!g_setting.IsExistINIFile())CreateDefaultSetting();

	MainWnd mw(hInstance);
	if(!mw.Create())return 1;

	{
		const TCHAR *cmdl = ::GetCommandLine();
		bool dq = false;
		for(;*cmdl;++cmdl){
			if(*cmdl == ' ' && !dq){++cmdl;break;}
			else if(*cmdl == '\"')dq = !dq;
		}
		ablib::CmdLine cmd(cmdl);
		if(!cmd.parse()){
			mw.GetWindow()->MsgBox(cmd.errmsg(),_T("TeXShell2"));
		}else{
			if(mw.CmdLine(cmd))return 0;
		}
	}

	MSG msg;
	while(int ret = ::GetMessage(&msg,NULL,0,0)){
		if(ret == -1)break;
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
	return msg.wParam;
}
